#if !defined GLOBAL_H_SINTENDO_SEPTEMBER_1_2000
#define GLOBAL_H_SINTENDO_SEPTEMBER_1_2000

#include <ddraw.h>
#include <dsound.h>
#include <d3d.h>
#include <tchar.h>

#define UNICODE

// Defines
// Defines listed here are seen by most if not all files inside Sintendo, but NOT Snes9x
// For a define to be seen by Snes9x, it should be placed in snes9x/port.h

// Standard defines - Leave uncommented for normal operation
#define MENU_640_480				// Currently does not work properly without this defined.
#define USE_DIRECT_INPUT			// Commenting out disables input
#define USE_DIRECT_X				// Commenting out disables video output (useful for tracing)
#define DO_SNES9X					// Commenting out disables ROM emulation
#define USE_BITMAPS					// Commenting out disables background bitmap loading - useless
#define DO_SAVING					// Commenting out disables saving - useless
#define DO_SOUND					// Commenting out disables all sound code

// Debug defines - Comment out for normal operation
//#define WINDOWED					// Windowed mode, currently useless
//#define SHOW_S9XMESSAGE			// Uncommenting displays all debug messages
//#define S9XMESSAGE_WAIT_FOR_INPUT	// Forces S9xMessage to wait for input instead of 1 second
//#define DEBUG_FILEIO				// Uncommenting displays file I/O messages (via S9xMessage)
//#define DEBUG_MENU				// Uncommenting displays menu messages (via S9xMessage)
//#define DEBUG_FLASH				// Uncommenting displays flash debug messages (via MessageBox)
#define DEBUG_INPUT
//#define DEBUG_SOUND
//#define SHOW_MEMORY_MANAGER		// Read Memory.cpp for information

#if defined USE_DIRECT_X
//#define RENDER_DIRECT_TO_VIDEO_MEMORY
#endif

// Ambiguous defines - If it doesn't work one way, try the other
#define FILEIO_USEWINCE			// Use WindowsCE functions to access files. otherwise use stdio
								// Currently, WINCE routines work

extern LPDIRECTDRAW4				gpdd_directdraw;
extern LPDIRECTDRAWSURFACE4			gdds_screen;
extern LPDIRECTDRAWSURFACE4			gdds_back;
extern BOOL							gb_enabled;
extern HWND							ghwd_window;
extern LPDIRECT3D3					gd3d_direct3d;
extern LPDIRECT3DDEVICE3			gdev_device;
extern HWND							ghwd_window;

extern HINSTANCE					gh_inst;

extern LPDIRECTSOUNDBUFFER			glpdsb_menuclick;

extern int							gint_skipframes;
extern int							gint_skipoutof;

extern bool							gb_dosave;
extern int							gint_videomode;

extern int							gint_primary;
extern int							gint_port;

extern bool							gb_insaveloadmenu;

extern char							gp_SRAMFile[13];

LPDIRECTDRAWSURFACE4 LoadBitmap(int res);
extern LPCTSTR ErrorMsg(int iError);

// I had to add this to the externals for debugging purposes
// I'll take it out later
void DestroyAll(void);


#endif