#include "gui.h"			// To avoid improper function declarations
#include "global.h"
#include "resource.h"
#include <ddraw.h>
#include <Winbase.h>
#include <d3d.h>
#include "input.h"
#include "emu.h"
#include <tchar.h>
#include "snes9x/memmap.h"
#include "bitmap.h"
#include "Direct3D.h"
#include "DCFlash.h"
#include "Memory.h"
#include "Menu.h"
#include "Sound.h"

#include "snes9x/snes9x.h"
#include "snes9x/cpuexec.h"

#define D3D_OVERLOADS
#define DO_SAVING

#define SPLASH_WAIT		1000	// Splash screen wait time, in milliseconds

#if defined MENU_640_480
	#define SCREENX			640
	#define SCREENY			480
	#define MENU_BORDER		64
	#define FONT_SIZE		32
	#define SMALL_FONT_SIZE	24
	#define ICONX			40
	#define ICONY			30
	#define LEFTOF_ICON		6
	#define LEFTOF_TEXT		8
	#define MEMORY_CARD_TOP_BOTTOM				64
	#define MEMORY_CARD_HEIGHT					120
	#define MEMORY_CARD_UP_DOWN_SEPERATOR		24
	#define MEMORY_CARD_LEFT_RIGHT				24
	#define MEMORY_CARD_WIDTH					98
	#define MEMORY_CARD_LEFT_RIGHT_SEPERATOR	24
	
#else
	#define SCREENX			320
	#define SCREENY			240
	#define MENU_BORDER		32
	#define FONT_SIZE		16
	#define SMALL_FONT_SIZE	12
	#define ICONX			19
	#define ICONY			15
	#define LEFTOF_ICON		3
	#define LEFTOF_TEXT		4
#endif

#define MAX_ROMS			256

int DoGameMenu(TCHAR* folder, bool allowcancel = false, bool showback = false);
void DoSaveLoadMenu(bool);
void DoFrameSkipMenu(void);
void DoTransparencyMenu(void);
void DoVideoModeMenu(void);

#ifdef USE_DIRECT_X
int gint_skipframes = 0;
int gint_skipoutof = 0;
#else
int gint_skipframes = 5;
int gint_skipoutof = 8;
#endif

bool gb_dosave = false;
int	gint_videomode = 0;
int skipmenu = 0;
bool gb_insaveloadmenu = false;
char gp_SRAMFile[13];
bool inemulation = false;

static LPDIRECTDRAWSURFACE4 splash = NULL;
LPDIRECTSOUNDBUFFER glpdsb_menuclick = NULL;

// Global variables, usually gotten once and then left set, such as fonts or video buffers
// of particular use

static HFONT ghFontLarge = NULL, ghFontSmall = NULL;
static LPDIRECTDRAWSURFACE4 gSurfAccept = NULL, gSurfCancel = NULL, gSurfEnd = NULL;

void FlipScreen(void) {
	gdds_screen->Flip(NULL, DDFLIP_WAIT);
//	CheckForDevices();
}

void SetupGlobal(void) {
	LOGFONT lf;
	if(!ghFontLarge) {
		memset(&lf, 0, sizeof(lf));
		lf.lfHeight = 32;
		lf.lfWeight = FW_BOLD;
		ghFontLarge = CreateFontIndirect(&lf);

		memset(&lf, 0, sizeof(lf));
		lf.lfHeight = 24;
		//lf.lfWeight = FW_BOLD;
		ghFontSmall = CreateFontIndirect(&lf);
	}

	if(!gSurfAccept) {
		gSurfAccept = LoadBitmap(IDB_ACCEPT);
		gSurfCancel = LoadBitmap(IDB_DONTSAVE);
		gSurfEnd = LoadBitmap(IDB_END);
	}
}

OptionStruct yn[] = {
	{ _T("Yes"), NULL, alignCENTER },
	{ _T("No"), NULL, alignCENTER }};

extern void DoGUI(void) {
//	GUI gui;

//	gui.DoGameMenu();

	HRESULT hr;
	
	SetupMenu();
//	MessageBox(_T("Generic MessageBox"));
	JoystickInit();

#if defined DO_SOUND
	hr = InitDirectSound();
	if(FAILED(hr)) {
		MessageBox(_T("InitDirectSound Failed"));
		MessageBox(ErrorMsg(hr));
	}

	LPDIRECTSOUNDBUFFER lpdsb;
	glpdsb_menuclick = LoadSoundBuffer(_T("#156"));
	hr = glpdsb_menuclick->Play(0, 0, 0);
	MessageBox(_T("Play IDR_WAVE1"));
	MessageBox(ErrorMsg(hr));
#endif

	TCHAR* text1 = _T("Sintendo v0.10");
	const TCHAR* str[] = { _T("Sintendo v0.10"),
		_T("Would you like to enable"),
		_T("saving for this game?"),
		_T("") };

//	OptionStruct os[] = {
//		{ _T("Folder Filler"), iconFOLDER, alignLEFT },
//		{ _T("Folder Filler"), iconFOLDER, alignLEFT },
//		{ _T("Folder Filler"), iconFOLDER, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Game Filler"), iconCART, alignLEFT },
//		{ _T("Yes"), iconFOLDER, alignLEFT },
//		{ _T("No"), iconFOLDER, alignLEFT }};

//	int i = DoMenu(1, str, 20, os, NULL, widthMAX, heightFIT, false);
//	char str2[256];
//	sprintf(str2, "You selected option: %i", i);
//	S9xMessage(0, 0, str2);
//	DoMenu(4, NULL, 3, NULL);
//	DoMenu(4, str, 2, yn, NULL, widthFIT, heightFIT, false);

#if defined USE_DIRECT_X
//#if defined USE_BITMAPS
	DWORD tick;

	srand(GetTickCount() % 0xFFFF);

	SetupGlobal();

	DoMemoryManager(_T("After Initalization"));
/*	if(DoYesNoMenu("Welcome to Sintendo",
		"I hope you enjoy your stay",
		"Please fasten your seatbelts")) {

		S9xMessage(0, 0, "You selected YES");

	} else {
		S9xMessage(0, 0, "You selected NO");
	} */

#if defined UNDER_CE
	splash = LoadBitmapFromFile("\\CD-ROM\\splash.bmp");
#else
	splash = LoadBitmapFromFile("splash.bmp");
#endif
	
	DoMemoryManager(_T("After LoadBitmap()"));

	gdds_back->Blt(NULL, splash, NULL, DDBLT_WAIT, NULL);

	FlipScreen();

	tick = GetTickCount();							// Set the timer
	while(GetTickCount() < tick + SPLASH_WAIT);		// Wait
//#endif
#endif

#if defined DO_SNES9X
	DoSnes9xInit();
	DoMemoryManager(_T("After DoSnes9xInit()"));
#endif

	FlashInit();
//	DoSaveLoadMenu(true);
	DoGameMenu(TEXT("SNES"));

	DoMemoryManager(_T("Before Emulation"));

#if defined DO_SNES9X
	DoSnes9xEmulation();
#endif
}

//////////////////////////////////
// GetFolderInformation()
//////////////////////////////////
HANDLE GetFolderInformation(TCHAR* folder, int &n, OptionStruct os[], bool showback) {
	HANDLE hDir = NULL;
	n = 0;

#ifdef UNDER_CE	
	TCHAR path[256] = TEXT("\\CD-ROM\\");
#else
	TCHAR path[256] = TEXT("");
#endif

	_tcscat(path, folder);

#ifdef UNDER_CE
	hDir = CreateFile(path,
                   GENERIC_READ,
                   FILE_SHARE_READ,
                   NULL,
                   OPEN_EXISTING,
                   FILE_FLAG_BACKUP_SEMANTICS,
                   NULL);
#endif

#ifdef UNDER_CE
	if(showback) {
		_tcscpy(os[n].text, _T(".."));
		os[n].align = alignLEFT;
		os[n].icon = iconFOLDER;
		n++;
	}
#endif

	// Get file information
	WIN32_FIND_DATA fd;
	HANDLE hand;
	BOOL ok = TRUE;

	TCHAR search[256];

	_tcscpy(search, path);
	_tcscat(search, TEXT("\\*"));

	hand = FindFirstFile(search, &fd);
	
	while(ok && n <= MAX_ROMS) {
		ok = FindNextFile(hand, &fd);
		if(!ok) break;
		if(!showback && n == 0) {
			showback = true;
			continue;
		}
		if(!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) continue;
		_tcscpy(os[n].text, fd.cFileName);
		os[n].align = alignLEFT;
		os[n].icon = iconFOLDER;
		n++;
	}
	FindClose(hand);

	ok = TRUE;

	_tcscpy(search, path);
	_tcscat(search, TEXT("\\*.smc"));

	hand = FindFirstFile(search, &fd);
	if(hand == INVALID_HANDLE_VALUE) {
		FindClose(hand);
		return hDir;
	}
	_tcscpy(os[n].text, fd.cFileName);
	*(_tcschr(os[n].text, '.')) = 0;
	os[n].align = alignLEFT;
	os[n].icon = iconCART;
	n++;
	
	while(ok && n <= MAX_ROMS) {
		ok = FindNextFile(hand, &fd);
		if(!ok) break;
		_tcscpy(os[n].text, fd.cFileName);
		*(_tcschr(os[n].text, '.')) = 0;
		os[n].align = alignLEFT;
		os[n].icon = iconCART;
		n++;
	}

	FindClose(hand);
	return hDir;
}

////////////////////////////////////////////////////////////////////
// DoGameMenu
////////////////////////////////////////////////////////////////////
int DoGameMenu(TCHAR* folder, bool allowcancel, bool showback) {
    DDSURFACEDESC2			ddsd;       // Surface Descriptor
	LPDIRECTDRAWSURFACE4 pdds2, pdds3 = NULL;
	HRESULT hr;
	int n;

	OptionStruct os[MAX_ROMS];

	HANDLE hDir = GetFolderInformation(folder, n, os, showback);

/*#if defined USE_DIRECT_X

	memset(&ddsd, 0, sizeof(ddsd));
    gdds_screen->GetSurfaceDesc(&ddsd);  

    ddsd.dwSize         = sizeof(DDSURFACEDESC2);
    ddsd.dwFlags        = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;// | DDSCAPS_3DDEVICE;
    ddsd.ddsCaps.dwCaps = DDSCAPS_VIDEOMEMORY;

    ddsd.dwWidth        = 640;
    ddsd.dwHeight       = 480;
	// Video memory allocated, release upon return
    hr = gpdd_directdraw->CreateSurface(&ddsd, &pdds2, NULL);
	if(hr != DD_OK) {
		char str[256];
		sprintf(str, "Error creating DirectDraw surface. %s", ErrorMsg(hr));
		S9xMessage(0, 0, str);
	}
	S9xMessage(0, 0, "DirectDraw surface created OK");
	if(pdds3 != NULL) {
		pdds2->Blt(NULL, pdds3, NULL, DDBLT_WAIT, NULL);
		// Memory released
		pdds3->Release();
	} else {
		pdds2->Blt(NULL, splash, NULL, DDBLT_WAIT, NULL);
	}
	S9xMessage(0, 0, "Bitmap Moved"); 

	if(!allowcancel) {
		for(int i = 240; i >= -4;) {
			RECT srt = { 0, 240-i, 640, 240 };
			RECT drt = { 0, 0, 640, i };
			gdds_back->Blt(&drt, splash, &srt, DDBLT_WAIT, NULL);

			RECT srt2 = { 0, 240, 640, 240+i };
			RECT drt2 = { 0, 480-i, 640, 480 };
			gdds_back->Blt(&drt2, splash, &srt2, DDBLT_WAIT, NULL);

			RECT drt3 = { 0, i, 640, 480-i };
			RECT srt3 = { 0, i, 640, 480-i };
			gdds_back->Blt(&drt3, pdds2, &srt3, DDBLT_WAIT, NULL);
			FlipScreen()

			i-= 4;
		}
	}

	gdds_back->Blt(NULL, pdds2, NULL, DDBLT_WAIT, NULL);
	FlipScreen()

#endif

*/
	TCHAR *p, *ps = folder;
	while(p = _tcschr(ps, '\\')) ps = p + 1;

	TCHAR title[256] = _T("Sintendo Beta v0.10 - ");
	const TCHAR* text[] = { title };

	_tcscat(title, ps);

	int select;
	int newmenu = 1;

	do {
		select = DoMenu(1, text, n, os, NULL, widthMAX, heightFIT, 0, allowcancel);
	
		if(select == -1) {
//			delete os;
#ifdef UNDER_CE
			CloseHandle(hDir);
#endif
			return false;
		}

		if(select == 0 && showback) return -1;

		newmenu = 2;
		if(os[select].icon == iconFOLDER) {
			TCHAR newfolder[256];
			_tcscpy(newfolder, folder);
			_tcscat(newfolder, _T("\\"));
			_tcscat(newfolder, os[select].text);

			newmenu = DoGameMenu(newfolder, allowcancel, true);
		}

		// If it loaded a game, or was canceled, we are done here
		if(newmenu == 1 || newmenu == 0) {
//			delete os;
#ifdef UNDER_CE
			CloseHandle(hDir);
#endif
			return newmenu;
		}
	} while(newmenu == -1);

	inemulation = true;

	TCHAR path[256];
	memset(path, 0, sizeof(TCHAR) * 256);
	
#ifdef UNDER_CE	
	_tcscpy(path, _T("\\CD-ROM\\"));
#else
	_tcscpy(path, _T(""));
#endif

	_tcscat(path, folder);
	_tcscat(path, _T("\\"));
	_tcscat(path, os[select].text);
	_tcscat(path, _T("\0"));

	char str[256];
	memset(str, 0, sizeof(char) * 256);

#if defined UNDER_CE
	wcstombs(str, path, 255);
#else
	strcpy(str, path);
#endif

	strcat(str, ".smc");
	strcat(str, "\0");

	const TCHAR* txt[] = { _T(" "), _T("Loading..."), _T(" ") };
	DoMenu(3, txt, 0, NULL, NULL, widthFIT, heightFIT, 0, false, false);

	S9xReset();
	Memory.LoadROM(str);

	gb_dosave = false;
	if(Memory.SRAMSize == 0) {
#ifdef UNDER_CE
		CloseHandle(hDir);
#endif
		return true;		// Don't save
	}

#ifdef UNDER_CE
	char *fname = (char *)os[select].text;

	int j = 0;
	for(int i = 0; i < 7; i++) {
		gp_SRAMFile[i] = fname[j];
		j += 2;
	}

// THis is here because I didn't feel like really solving the problem :)
#if defined UNDER_CE
	j = wcslen(os[select].text) * 2;
#else
	j = strlen(os[select].text);
#endif
	j -= 10;
	for(i = 7; i < 12; i++) {
		gp_SRAMFile[i] = fname[j];
		j += 2;
	}

	gp_SRAMFile[12] = 0;

	for(i = 0; i < 12; i++) {
		if(gp_SRAMFile[i] == ' ') gp_SRAMFile[i] = '_';
	}

	if(gint_primary == -1) {
#ifdef UNDER_CE
		CloseHandle(hDir);
#endif
		return true;			// Don't save
	}

	TCHAR s[256];

	if(FlashFindFile(gp_SRAMFile)) {
		const TCHAR* txt2[] = { _T(" "), _T("Loading VMS Save File..."), _T(" ") };
		DoMenu(3, txt2, 0, NULL, NULL, widthFIT, heightFIT, 0, false, false);

		Memory.LoadSRAM(gp_SRAMFile);

		const TCHAR* txt3[] = { _T(" "), _T("VMS File Loaded"), _T(" ") };
		DoMenu(3, txt3, 0, NULL, NULL, widthFIT, heightFIT, 0, false);

		gb_dosave = true;
	} else {
		BOOL t;

		_stprintf(s, _T("This game requires %i Blocks."), GetSRAMSize());
		
		const TCHAR* txt4[] = { _T("No save data found."), s, _T("Do you wish to enable saving?") };

		if(DoMenu(3, txt4, 2, yn, NULL, widthFIT, heightFIT, 0, false) == 0) {

			MessageBox(_T("Creating VMS File..."), false);
			t = FlashCreateFile(gp_SRAMFile, gp_SRAMFile, Memory.SRAMSize);

			if(t == TRUE) {
				const TCHAR* txt3[] = { _T(" "), _T("VMS File Created"), _T(" ") };
				DoMenu(3, txt3, 0, NULL, NULL, widthFIT, heightFIT, 0, false);

				gb_dosave = true;
			} else {
				const TCHAR* txt3[] = { _T(" "), _T("Error Creating VMS File"),
					_T("Enough space may not be available"), _T(" ") };
				DoMenu(4, txt3, 0, NULL, NULL, widthFIT, heightFIT, 0, false);
			}
		}
	}

/*	sprintf(str, "Memory.ROMName = %s", Memory.ROMName);
	S9xMessage(0, 0, str);
	sprintf(str, "Memory.ROMFilename = %s", Memory.ROMFilename);
	S9xMessage(0, 0, str);
	sprintf(str, "Memory.ROMId = %s", Memory.ROMId);
	S9xMessage(0, 0, str);
	sprintf(str, "SRAMFile = %s", SRAMFile);
	S9xMessage(0, 0, str);
	sprintf(str, "SRAMFile2 = %s", SRAMFile2);
	S9xMessage(0, 0, str); */
#endif

//	delete os;
#ifdef UNDER_CE
	CloseHandle(hDir);
#endif
//	pdds2->Release();  

	return true; 
}

////////////////////////////////////////////////////////////////////
// DoInGameMenu
////////////////////////////////////////////////////////////////////
void DoInGameMenu(void) {

	if(gb_dosave) {
		const TCHAR* txt2[] = { _T(" "), _T("Saving VMS File..."), _T(" ") };
		DoMenu(3, txt2, 0, NULL, NULL, widthFIT, heightFIT, 0, false, false);

		Memory.SaveSRAM("test.srm");
	}

    DDSURFACEDESC2 ddsd;
	HRESULT hr;

	const int nOPTIONS = 8;
	OptionStruct os[nOPTIONS] = {
		{ _T("Return to Game"), iconRETURN, alignLEFT },
		{ _T("Game Menu"), iconCART, alignLEFT },
		{ _T("Reset SNES"), iconRESET, alignLEFT },
		{ _T("Controller Config"), iconCONTROLLER, alignLEFT },
		{ _T("Frameskip"), iconVIDEO, alignLEFT },
		{ _T("Transparency"), iconVIDEO, alignLEFT },
		{ _T("Video Mode"), iconVIDEO, alignLEFT },
		{ _T("Credits"), iconVIDEO, alignLEFT } };
	
	const TCHAR* text[] = { _T("Game Paused") };

	int select;

	do {
	select = DoMenu(1, text, nOPTIONS, os, NULL, widthMAX, heightFIT, 0, true);

	switch(select) {
		case 2:
			S9xReset();
			return;
		case 1:
			DoGameMenu(TEXT("SNES"), true);
			return;
		case 6:
			DoVideoModeMenu();
			break;
		case 4:
			DoFrameSkipMenu();
			break;
		case 5:
			DoTransparencyMenu();
			break;
		case 3:
		case 7:
		case 0:
			return;
	}
	} while(select != -1);
}

////////////////////////////////////////////////////////////////////
// DoSaveLoadMenu
////////////////////////////////////////////////////////////////////
void DoSaveLoadMenu(bool save) {
#ifdef UNDER_CE
#ifdef USE_DIRECT_X
	bool available[2][4];
	memset(available, 0, sizeof(bool) * 12);

	int select = 0;
	int selx = 0;
	int sely = 0;
	int movedlast = -5;
	
	GetCurrentFlashPort(&selx, &sely);
	if(selx == -1) selx = 0;
	if(sely == -1) sely = 0;

    DDBLTFX					ddbltfx;
	DWORD					tick;

	gb_insaveloadmenu = true;

	while(1) {

		// Direct3D calls
		gdev_device->BeginScene();
//		AlphaBlt(device, pdds2, 0, 0, 640, 480, 1.0);
		FillGradientRect(gdev_device, 0,0,640,480,0xFFFFFFFF, D3DRGBA(0.5,0.5,0.5,1), D3DRGBA(0.5,0.5,0.5,1),
			D3DRGBA(0,0,0,1));

		// Draw the menu box
		FillGradientRect(gdev_device, MENU_BORDER, MENU_BORDER, SCREENX - MENU_BORDER, SCREENY - MENU_BORDER,
			D3DRGBA(0.0, 0.2, 1.0, 0.5), D3DRGBA(0.0, 0.2, 1.0, 0.5), 
			D3DRGBA(0.0, 0.2, 1.0, 0.5), D3DRGBA(0.0, 0.2, 1.0, 0.5));

		int y = MENU_BORDER + MEMORY_CARD_TOP_BOTTOM;
		int x = MENU_BORDER + MEMORY_CARD_LEFT_RIGHT;

		for(int i = 0; i < 4; i++) {
			for(int j = 0; j < 2; j++) {
				D3DCOLOR d3dc;
				if(GetFlashStatus(i, j) != -1) {
					d3dc = D3DRGBA(0.5, 0.5, 1.0, 1.0);
				} else {
					d3dc = D3DRGBA(0.3, 0.3, 0.5, 1.0);
				}
				FillGradientRect(gdev_device, x, y, x + MEMORY_CARD_WIDTH,
					y + MEMORY_CARD_HEIGHT, d3dc, d3dc, d3dc, d3dc);

				if(i == selx && j == sely) {
					FillGradientRect(gdev_device, x-5, y-5, x + MEMORY_CARD_WIDTH + 5,
						y + MEMORY_CARD_HEIGHT + 5, 
						D3DRGBA(0.0, 0.3, 1.0, 0.8), D3DRGBA(0.0, 0.3, 1.0, 0.8),
						D3DRGBA(0.0, 0.0, 0.3, 0.8), D3DRGBA(0.0, 0.0, 0.3, 0.8));
				}

				y += MEMORY_CARD_HEIGHT + MEMORY_CARD_UP_DOWN_SEPERATOR;
			}
			y = MENU_BORDER + MEMORY_CARD_TOP_BOTTOM;
			x += MEMORY_CARD_WIDTH + MEMORY_CARD_LEFT_RIGHT_SEPERATOR;
		}

		
		gdev_device->EndScene();

		// Draw accept
		x = 640/2 - (90 + 119) / 2;
		y = 480 - 32 - 14;
		RECT r1 = { x, y, x + 90, y + 27 };
		gdds_back->Blt(&r1, gSurfAccept, NULL, DDBLT_WAIT, NULL);
		RECT r3 = { x+90, y, x+90+119, y + 27 };
		gdds_back->Blt(&r3, gSurfCancel, NULL, DDBLT_WAIT, NULL);
		
		// Draw the text
		HDC	dc;
		gdds_back->GetDC(&dc);

		SelectObject(dc, ghFontLarge);
		SetBkMode(dc, TRANSPARENT);

		SIZE sz;
		SetTextColor(dc, RGB(0, 0, 0));
		GetTextExtentPoint32(dc, TEXT("Select Memory Card"), 18, &sz);
		x = SCREENX / 2 - sz.cx / 2;
		ExtTextOut(dc, x, MENU_BORDER + 16, NULL, NULL, TEXT("Select Memory Card"), 18, NULL);

		TCHAR str[256];
		x = MENU_BORDER + MEMORY_CARD_LEFT_RIGHT + MEMORY_CARD_WIDTH / 2;
		y = MENU_BORDER + MEMORY_CARD_TOP_BOTTOM + MEMORY_CARD_HEIGHT / 2 - sz.cy;

		SetTextColor(dc, RGB(255, 255, 255));
		int free = 0;
		for(i = 0; i < 4; i++) {
			for(int j = 0; j < 2; j++) {
				free = GetFlashStatus(i, j);
				if(free != -1) {
					wsprintf(str, TEXT("%i"), free);
					GetTextExtentPoint32(dc, str, _tcslen(str), &sz);
					ExtTextOut(dc, x - sz.cx / 2, y, NULL, NULL, str, _tcslen(str), NULL);
					GetTextExtentPoint32(dc, TEXT("Free"), 4, &sz);
					ExtTextOut(dc, x - sz.cx / 2, y + sz.cy, NULL, NULL, TEXT("Free"), 4, NULL);
				}

				y += MEMORY_CARD_HEIGHT + MEMORY_CARD_UP_DOWN_SEPERATOR;
			}
			y = MENU_BORDER + MEMORY_CARD_TOP_BOTTOM + MEMORY_CARD_HEIGHT / 2 - sz.cy;
			x += MEMORY_CARD_WIDTH + MEMORY_CARD_LEFT_RIGHT_SEPERATOR;
		}

/*		SelectObject(dc, ghFontSmall);
		SetTextColor(dc, RGB(255, 255, 255));
		x = 38;
		for(int j = 0; j < 4; j++) {
			if(available[0][i]) 
				SetTextColor(dc, RGB(255, 255, 255));
			else
				SetTextColor(dc, RGB(64, 64, 64));
			TCHAR str[256];
			wsprintf(str, TEXT("File %i"), j);
			ExtTextOut(dc, x, 46, NULL, NULL, str, _tcslen(str), NULL);
			x += 128; 
		} */
		
		gdds_back->ReleaseDC(dc); 
		
		FlipScreen();
		CheckForDevices();

		if(!movedlast) {
			for(int d = 0; d < 4; d++) {
				int a = GetInputDeviceData(d);
				if((a | UP) == a || (a | BUTTON[3]) == a) {
					sely--;
					if(sely < 0) sely = 0;
					break;
				}
				if((a | DOWN) == a || (a | BUTTON[4]) == a) {
					sely++;
					if(sely > 1) sely = 1;
					break;
				}
				if((a | LEFT) == a || (a | BUTTON[5]) == a) {
					selx--;
					if(selx < 0) selx = 0;
					break;
				}
				if((a | RIGHT) == a || (a | BUTTON[6]) == a) {
					selx++;
					if(selx > 3) selx = 3;
					break;
				}
				if((a | BUTTON[1]) == a) {
					if(GetFlashStatus(selx, sely) == -1) break;
					gint_primary = selx;
					gint_port = sely;
					gb_insaveloadmenu = false;
//					const TCHAR* txt3[] = { _T(" "), _T("OK"), _T(" ") };
//					DoMenu(3, txt3, 0, NULL, NULL, widthFIT, heightFIT, 0, false);
					if(inemulation) {
//						const TCHAR* txt3[] = { _T(" "), _T("InEmulation"), _T(" ") };
//						DoMenu(3, txt3, 0, NULL, NULL, widthFIT, heightFIT, 0, false);
//						DoMemoryManager(_T("FlashFindFile()"));
						if(FlashFindFile(gp_SRAMFile)) {
							const TCHAR* txt3[] = { 
								_T("VMS File for this game found."),
								_T("Would you like to load this"),
								_T("and Reset now?") 
							};
							int select = DoMenu(3, txt3, 2, yn, NULL, widthFIT, heightFIT, 0, false);
							if(select == 0) {
								MessageBox(_T("Loading VMS Save File..."));
								Memory.LoadSRAM(gp_SRAMFile);
								S9xReset();
							} else {
								const TCHAR* txt4[] = { _T("Overwrite VMS File?") };
								select = DoMenu(1, txt4, 2, yn, NULL, widthFIT, heightFIT, 0, false);

								if(select == 0) {
									const TCHAR* txt2[] = { _T(" "), _T("Saving VMS File..."), _T(" ") };
									DoMenu(3, txt2, 0, NULL, NULL, widthFIT, heightFIT, 0, false, false);

									Memory.SaveSRAM("test.srm");
								} else {
									const TCHAR* txt2[] = { _T(" "), _T("Saving Disabled"), _T(" ") };
									DoMenu(3, txt2, 0, NULL, NULL, widthFIT, heightFIT, 0, false);

									gb_dosave = false;
								}
							}								
						} else {
							TCHAR s[256];
							_stprintf(s, _T("This game requires %i Blocks."), GetSRAMSize());
							
							const TCHAR* txt4[] = { _T("No save data found."), s, _T("Do you wish to enable saving?") };

							if(DoMenu(3, txt4, 2, yn, NULL, widthFIT, heightFIT, 0, false) == 0) {

								MessageBox(_T("Creating VMS File..."), false);
								FlashCreateFile(gp_SRAMFile, gp_SRAMFile, Memory.SRAMSize);
							} else {
								MessageBox(_T("Saving Disabled"));
								gb_dosave = false;
							}
						}	
					}
					return;
				}
				if((a | BUTTON[0]) == a) {
					gint_primary = -1;
					gint_port = -1;
					gb_dosave = false;
					gb_insaveloadmenu = false;
					return;
				}
				if(a) break;
			}
			movedlast++;
		} else {
			if(movedlast < 1) movedlast++;
			else movedlast = 0;
		} 

//		gdds_back->Blt(NULL, gdds_screen, NULL, DDBLT_WAIT, NULL);
	} 
//	}

	MSG msg;
	while(1) {
		if(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
			if(!GetMessage(&msg, NULL, 0, 0))
				return;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	} 
#endif
#endif
}

////////////////////////////////////////////////////////////////////
// DoFrameSkipMenu
////////////////////////////////////////////////////////////////////
void DoFrameSkipMenu() {

	static int select;
	
//	const int nSkipOption = 12;
//	const int skipoption1[nSkipOption] = { 0, 1, 1, 1, 1, 3, 1, 5, 2, 3, 5, 7 };
//	const int skipoption2[nSkipOption] = { 0, 8, 6, 4, 3, 8, 2, 8, 3, 4, 6, 8 };
//	const int nSkipOption = 20;
//	const int skipoption1[nSkipOption] = { 0, 1,  1, 1, 3,  1, 5,  1, 3, 7,  1, 9,  5, 2, 11,
//		3, 5, 13, 7, 15 };
//	const int skipoption2[nSkipOption] = { 0, 16, 8, 6, 16, 4, 16, 3, 8, 16, 2, 16, 8, 3, 16, 
//		4, 6, 16, 8, 16 };
	const int nSkipOption = 24;
	const int skipoption1[nSkipOption] = { 0, 5,   5,  15,  10, 25,  15, 35,  20, 45,  25, 55,  
		30, 65,  35, 75,  40, 85,  45, 95,  50, 105, 55, 115 };
	const int skipoption2[nSkipOption] = { 0, 120, 60, 120, 60, 120, 60, 120, 60, 120, 60, 120, 
		60, 120, 60, 120, 60, 120, 60, 120, 60, 120, 60, 120};

	OptionStruct os[nSkipOption] = {
		{ _T("Skip 0 Frames"), NULL, alignLEFT },
		{ _T("Skip 2.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 7.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 10 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 12.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 15 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 17.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 20 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 22.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 25 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 27.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 30 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 32.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 35 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 37.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 40 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 42.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 45 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 47.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 50 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 52.5 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 55 Frames of 60"), NULL, alignLEFT },
		{ _T("Skip 57.5 Frames of 60"), NULL, alignLEFT } };
	
	const TCHAR* text[] = { _T("Frame Skip") };

	int sel = DoMenu(1, text, nSkipOption, os, NULL, widthMAX, heightFIT, select, true); 
	if(sel == -1) return;
	select = sel;

	gint_skipframes = skipoption1[select];
	gint_skipoutof = skipoption2[select];
}

////////////////////////////////////////////////////////////////////
// DoTransparencyMenu
////////////////////////////////////////////////////////////////////
void DoTransparencyMenu() {

	static int select;

	OptionStruct os[2] = {
		{ _T("Off"), NULL, alignCENTER },
		{ _T("On"), NULL, alignCENTER },
	};
	
	const TCHAR* text[] = { _T("Transparency") };

	int sel = DoMenu(1, text, 2, os, NULL, widthFIT, heightFIT, select, true); 
	if(sel == -1) return;
	select = sel;

	S9xGraphicsDeinit();
	Settings.Transparency = sel;
	S9xGraphicsInit();
}

////////////////////////////////////////////////////////////////////
// DoVideoModeMenu
////////////////////////////////////////////////////////////////////
void DoVideoModeMenu() {

	static int select;
	
	OptionStruct os[3] = {
		{ _T("TV Mode (Small Borders)"), NULL, alignLEFT },
		{ _T("TV Mode (Large Borders)"), NULL, alignLEFT },
		{ _T("VGA Mode"), NULL, alignLEFT } };
	
	const TCHAR* text[] = { _T("Video Mode") };

	int sel = DoMenu(1, text, 3, os, NULL, widthFIT, heightFIT, select, true); 
	if(sel == -1) return;
	select = sel;

	gint_videomode = select;
}