// Memory manager
// A menu to display information about memory allocation and availablity
// This file is not actually needed if SHOW_MEMORY_MANAGER is not defined in global.h
// For normal program operation, SHOW_MEMORY_MANAGER should not be defined
// It is used for debugging purposes.
#include "global.h"

#include <winbase.h>
#include <stdio.h>
#include "menu.h"

void DoMemoryManager(const TCHAR *title) {
#ifdef SHOW_MEMORY_MANAGER
	MEMORYSTATUS ms;

	ms.dwLength = sizeof(ms);

	GlobalMemoryStatus(&ms);

	OptionStruct os[4];
	
	TCHAR str[256];

	_stprintf(str, _T("Memory Load: %i%%"), ms.dwMemoryLoad);
	_tcscpy(os[0].text, str);
	os[0].align = alignLEFT;
	os[0].icon = NULL;

	_stprintf(str, _T("Physical Memory: %i/%i"), ms.dwAvailPhys, ms.dwTotalPhys);
	_tcscpy(os[1].text, str);
	os[1].align = alignLEFT;
	os[1].icon = NULL;
	
	_stprintf(str, _T("Page File: %i/%i"), ms.dwAvailPageFile, ms.dwTotalPageFile);
	_tcscpy(os[2].text, str);
	os[2].align = alignLEFT;
	os[2].icon = NULL;

	_stprintf(str, _T("Virtual Memory: %i/%i"), ms.dwAvailVirtual, ms.dwTotalVirtual);
	_tcscpy(os[3].text, str);
	os[3].align = alignLEFT;
	os[3].icon = NULL;

	_stprintf(str, _T("Memory Manager - %s"), title);

	const TCHAR* txt[] = { str };
	DoMenu(1, txt, 4, os, NULL, widthMAX, heightFIT, 0, false, true);
#endif
}
